<?php
/**
 * @package            Joomla
 * @subpackage         Event Booking
 * @author             Tuan Pham Ngoc
 * @copyright          Copyright (C) 2010 - 2020 Ossolution Team
 * @license            GNU/GPL, see LICENSE.php
 */

defined('_JEXEC') or die;

class EventbookingHelperOverrideCart extends EventbookingHelperCart
{
	/**
	 * Add several events into shopping cart
	 *
	 * @param   array  $cid
	 */
	public function addEvents($cid)
	{
		$config     = EventbookingHelper::getConfig();
		$session    = JFactory::getSession();
		$cart       = $session->get('eb_cart');
		$quantities = $cart['quantities'];
		$items      = $cart['items'];

		if (count($cid))
		{
			foreach ($cid as $id)
			{
				if (!in_array($id, $items))
				{
					array_push($items, $id);
					array_push($quantities, 2);
				}
				else
				{
					//Find the id
					for ($i = 0, $n = count($items); $i < $n; $i++)
					{
						if ($items[$i] == $id)
						{
							$event = EventbookingHelperDatabase::getEvent($id);

							if ($event->prevent_duplicate_registration === '')
							{
								$preventDuplicateRegistration = $config->prevent_duplicate_registration;
							}
							else
							{
								$preventDuplicateRegistration = $event->prevent_duplicate_registration;
							}

							if ($preventDuplicateRegistration)
							{
								$quantities[$i] = 1;
							}
							else
							{
								$capacityCheck        = !$event->event_capacity || (($event->event_capacity - $event->total_registrants) > $quantities[$i]);
								$maxGroupMembersCheck = !$event->max_group_number || ($event->max_group_number < $quantities[$i]);

								if ($capacityCheck && $maxGroupMembersCheck)
								{
									$quantities[$i] += 1;
								}
							}

							break;
						}
					}
				}
			} //End Foreach
		}

		$cart['items']      = $items;
		$cart['quantities'] = $quantities;
		$session->set('eb_cart', $cart);
	}
}